#include "chip.h"

void chip_ioremap_init(void) {

    CHIP_REGS_RCC->APB2ENR |= CHIP_REGFLD_RCC_APB2ENR_AFIO_EN;

    CHIP_REGS_AFIO->MAPR = 0
                           | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_SW_CFG,        CHIP_IOREMAP_SDI_EN ? 0 : 4)
                           | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_PD01_REMAP,    CHIP_IOREMAP_PD01_OSC_EN ? 0 : 1)
                           | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_CAN1,     CHIP_IOREMAP_CAN1)
                           | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_TIM4,     CHIP_IOREMAP_TIM4)
                           | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_TIM3,     CHIP_IOREMAP_TIM3)
                           | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_TIM2,     CHIP_IOREMAP_TIM2 & 3)
                           | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_TIM1,     CHIP_IOREMAP_TIM1 & 3)
                           | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_USART1,   CHIP_IOREMAP_USART1 & 1)
                           | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_USART2,   CHIP_IOREMAP_USART2 & 1)
                           | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_USART3,   CHIP_IOREMAP_USART3)
                           | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_I2C1,     CHIP_IOREMAP_I2C1 & 1)
                           | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR_SPI1,     CHIP_IOREMAP_SPI1 & 1)
        ;

    CHIP_REGS_AFIO->MAPR2 = 0
                            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR2_LPTIM1, CHIP_IOREMAP_LPTIM1)
                            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR2_SPI1_H, (CHIP_IOREMAP_SPI1 >> 1) & 1)
                            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR2_I2C1_H, (CHIP_IOREMAP_I2C1 >> 1) & 1)
                            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR2_TIM1_H, (CHIP_IOREMAP_TIM1 >> 2) & 1)
                            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR2_TIM2_H, (CHIP_IOREMAP_TIM2 >> 2) & 1)
                            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR2_USART1_H, (CHIP_IOREMAP_USART1 >> 1) & 3)
                            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR2_USART2_H, (CHIP_IOREMAP_USART2 >> 2) & 1)
                            | LBITFIELD_SET(CHIP_REGFLD_AFIO_MAPR2_USART4, CHIP_IOREMAP_USART4)
        ;
}
